c      divide a chain into various domains
c      by Bin Xue, Aug. 2008 
c      thanks for the suggestion of Stella Veretnik
c
       program ppp
       implicit none
       integer mseq,mrec,mdom
       parameter (mseq=3000,mrec=40000,mdom=20)
       integer nseq,ip_seq(mseq),irestyp(mseq),isize0,ist,ilast,imid
       double precision xct(mseq),yct(mseq),zct(mseq),dij(mseq,mseq)
       character fname*35,zlist*9, chn_seq(mseq)*1
       double precision pw,resect(mseq),pcut,hcut
       integer length,ipdom(mdom),ndom,idom,ifg_dom,ipdd, ipara
       integer id,i,iz,istx,ilastx,imidx,ja,jb

       read(*,*) fname
       call readpdb(fname,mseq,mrec,nseq,irestyp,ip_seq,chn_seq,
     $              xct,yct,zct)

       pw = 0.43
       isize0 = 40

       do ipara = 1, 3

          call whichparameter(ipara,pcut,hcut,length)
c             pcut = 0.66
c             hcut = 0.36
c             length = 32

       ist = 1
       ilast = nseq
       ndom = 1 
       idom = ndom 
       ipdd = 0
       ifg_dom = 0

1055   continue

       do id = 1, ndom

       call findpos(mdom,nseq,ndom,id,ipdom,ist,ilast)

       call distance(mseq,nseq,ist,ilast,xct,yct,zct,dij)
       call ddomain_pot(pw,mseq,mrec,nseq,ist,ilast,irestyp,dij,resect)
       call pulldomain(isize0,pcut,hcut,length,mseq,nseq,
     $        ist,ilast,resect,imid)

         if (imid.gt.ist .and. imid.lt.ilast) then
           idom = idom + 1
             if (idom .gt. mdom) then
                write(*,*) 'exceed !'
                stop
             endif
           ipdd = ipdd + 1
           ipdom(ipdd) = imid
           ifg_dom = 1
          
         do i = 1, 2   

             call findpos2(ist,ilast,imid,i,istx,ilastx)        

             if (ilastx-istx .ge. isize0) then
      call distance(mseq,nseq,istx,ilastx,xct,yct,zct,dij)
      call ddomain_pot(pw,mseq,mrec,nseq,istx,ilastx,irestyp,dij,resect)
         
      call pulldomain(isize0,pcut,hcut,length,mseq,nseq,
     $        istx,ilastx,resect,imidx)                  
 
               if (imidx.gt.istx .and. imidx.lt.ilastx) then 
                  idom = idom + 1
                    if (idom .gt. mdom) then
                       write(*,*) 'exceed !!'
                       stop
                    endif
                  ipdd = ipdd + 1
                  ipdom(ipdd) = imidx
                  ifg_dom = 1
               endif
             endif

         enddo

         endif


       enddo  


          if(ifg_dom .eq. 1) then
             ndom = idom
             ifg_dom = 0
             call small_big(mdom,ipdd,ipdom)
             goto 1055
          endif

      do i = 1, ndom
      if (ndom .eq. 1) then 
         write(*,935) 1,chn_seq(1),ip_seq(1),chn_seq(nseq),ip_seq(nseq)
      else
         if (i. eq. 1) then
            write(*,935) 1,chn_seq(1),ip_seq(1),
     $                   chn_seq(ipdom(i)),ip_seq(ipdom(i))   
         elseif(i .eq. ndom) then
            write(*,935) i,chn_seq(ipdom(i-1)+1),ip_seq(ipdom(i-1)+1),
     $                   chn_seq(nseq),ip_seq(nseq)
         else
            write(*,935) i,chn_seq(ipdom(i-1)+1),ip_seq(ipdom(i-1)+1),
     $                   chn_seq(ipdom(i)),ip_seq(ipdom(i))
         endif
      endif
      enddo
935   format(I4,2(2x,a1,1x,I5))


       enddo

       end


       subroutine whichparameter(ipara,pcut,hcut,length)
       implicit none
       integer ipara, length
       double precision pcut, hcut

       if (ipara .eq. 1) then
          write(*,*) "AUTHORS-trained parameters"
          pcut = 0.81
          hcut = 0.18
          length = 38
       elseif (ipara .eq. 2) then
          write(*,*) "SCOP-trained parameters"
          pcut = 0.53
          hcut = 0.36
          length = 34
       elseif (ipara .eq. 3) then
          write(*,*) "CATH-trained parameters"
          pcut = 0.67
          hcut = 0.30
          length = 36
       endif

       end




       subroutine pulldomain(isize0,pcut,hcut,length,mseq,nseq,
     $    ist,ilast,resect,idip)
       implicit none
       integer isize0,mseq,nseq,length,ist,ilast,idip
       double precision pcut,hcut,resect(mseq)
       integer i,jm1,j,jm2,maxe(mseq,2),k,k1,k2
       double precision tmp,tmp1,tmp2,tmp0,tmp10,tmp20
       integer ikip,i0,idip0,kk1,kk2,ikp,i1,i2
       double precision de1,de2

        tmp0 = -100.0
        tmp10 = 100.0
        tmp20 = 100.0
        idip = 1
        ikp = 1

        i0 = 0
        idip0 = 1
        kk1 = 0
        kk2 = 0

        do i = isize0, ilast-isize0
          tmp = resect(i)

          jm1 = i
          tmp1 = tmp
           do j = ist, i
           tmp2 = resect(j)
             if(tmp2 .gt. tmp1) then
               tmp1 = tmp2
               jm1 = j
             endif
           enddo

           jm2 = i
           tmp1 = tmp
           do j = i, ilast-1
           tmp2 = resect(j)
             if(tmp2 .gt. tmp1) then
               tmp1 = tmp2
               jm2 = j
             endif
           enddo

           maxe(i,1) = jm1
           maxe(i,2) = jm2

           k1 = 0
           do k = jm1, i
           de1 = resect(k) - tmp
            if(de1 .gt. hcut) then
              k1 = k1 + 1
            else
              goto 901
            endif
           enddo

901        do k = jm1, ist, -1
           de1 = resect(k) - tmp
             if(de1 .gt. hcut) then
                k1 = k1 + 1
             else
                goto 902
             endif
           enddo

902        k2 = 0
           do k = jm2, ilast
           de1 = resect(k) - tmp
             if(de1 .gt. hcut) then
               k2 = k2 + 1
             else
               goto 903
             endif
           enddo

903        do k = jm2, i, -1
           de1 = resect(k) - tmp
             if(de1 .gt. hcut) then
                k2 = k2 + 1
             else
                goto 904
             endif
           enddo

904         continue
            goto 808
808         continue

         de1 = resect(maxe(i,1)) - tmp
         de2 = resect(maxe(i,2)) - tmp


         if(tmp.lt.tmp20 .and. de1.gt.hcut .and. de2.gt.hcut) then
            ikp = i
            tmp20 = tmp
         endif
         if((k1.gt.length .and. k2.gt.length)) then
           if(tmp .lt. tmp10) then
c              tmp0 = tt
              tmp10 = tmp
              idip = i
              kk1 = k1
              kk2 = k2

           endif
         endif


         enddo    

c                write(*,*) 'idip = ',idip,resect(idip)
c                write(*,*) 'maxe ',maxe(idip,1),maxe(idip,2)


c        if(resect(idip) .gt. pcut) idip = 1
        if(resect(idip) .gt. pcut) idip = ist


          i1 = idip
          i2 = ilast - idip
          if(i1.gt.isize0 .and. i2.gt.isize0) then
              
c             write(*,*) 1,ist,' - ',idip
c             write(*,*) 2,idip+1,' - ',ilast
              idip = idip
          else
c             write(*,*) 1,ist,' - ',ilast
             idip = ist
          endif


      end


        subroutine findpos(mdom,nseq,ndom,id,ipdom,ist,ilast)
        implicit none
        integer mdom,nseq,ndom,id,ipdom(mdom),ist,ilast

         if (ndom .gt. 1) then
         if (id .eq. 1) then
              ist = 1
              ilast = ipdom(id)
         elseif(id .eq. ndom) then
              ist = ipdom(id-1) + 1
              ilast = nseq
         else
              ist = ipdom(id-1) + 1
              ilast = ipdom(id)
         endif
         endif

        end



        subroutine findpos2(ist,ilast,imid,i,ista,ilasta)
        implicit none
        integer ist,ilast,imid,i,ista,ilasta

         if (i .eq. 1) then
            ista = ist
            ilasta = imid
         else
            ista = imid + 1
            ilasta = ilast
         endif

         end



       subroutine small_big(mdom,ipdd,ipdom)
       implicit none
       integer mdom,ipdd
       integer ipdom(mdom),itmp(mdom),i,ifg_min(mdom)
       integer id,imin,ip
       
       do i = 1, ipdd
         ifg_min(i) = 0
       enddo
 
       do id = 1, ipdd
          imin = 100000
       do i = 1, ipdd
         if (ifg_min(i) .eq. 0) then
         if (ipdom(i) .lt. imin) then
           imin = ipdom(i)
           ip = i
         endif
         endif
       enddo
           ifg_min(ip) = 1
           itmp(id) = imin     
       enddo

       do i = 1, ipdd
         ipdom(i) = itmp(i)
       enddo


       end




       subroutine distance(mseq,nseq,ist,ilast,xct,yct,zct,dij)
       implicit none
       integer mseq,nseq,ist,ilast
       double precision xct(mseq),yct(mseq),zct(mseq)
       double precision dx,dy,dz,dr,dij(mseq,mseq)
       integer i,j

        do i = ist, ilast-1
        do j = i+1, ilast
           dx = xct(i)-xct(j)
           dy = yct(i)-yct(j)
           dz = zct(i)-zct(j)
            dr = dx*dx + dy*dy + dz*dz
            dij(i,j) = dsqrt(dr)
            if(j.ne.i) dij(j,i) = dij(i,j)
        enddo
        enddo

        end





       subroutine ddomain_pot(pw,mseq,mrec,nseq,ist,ilast,
     $       irestyp,dij,resect)
       implicit none
       double precision pw
       integer mseq,mrec,nseq,ist,ilast,irestyp(mseq)
c       double precision xct(mseq),yct(mseq),zct(mseq)
c       double precision dx,dy,dz,dr,dij(mseq,mseq),rcut
       double precision dr,dij(mseq,mseq),rcut
       integer i,j,k
       integer it,jt,ipt1,ipt2
       double precision ave,ect,resect(mseq),tmp

           ave = 0.0
           rcut = 6.5
         do k = ist, ilast-1
             ect = 0.0
           do i = ist, k
           it = irestyp(i)
             do j = k+1, ilast
             jt = irestyp(j)
             dr = dij(i,j)

              if(dr .lt. rcut)  ect = ect - 1.0

             enddo
           enddo

           ipt1 = k - ist + 1
           ipt2 = (ilast-1) - k + 1

           ect = ect/(ipt1*ipt2)**pw
           resect(k) = ect
           ave = ave + ect

        enddo


        tmp = ave/((ilast-ist+1)-1)
        do k = ist, ilast-1
          resect(k) = resect(k)/tmp
        enddo

       end




       subroutine readpdb(fname,mseq,mrec,nseq,irestyp,ip_seq,chn_seq,
     $            xct,yct,zct)
       implicit none
       integer mseq,mrec,nseq,nrec
       integer mres
       parameter (mres=20)
       integer id,ires0,ires1,ires,resnum(mseq)
       integer irestyp(mseq),ip_seq(mseq)
       character cread(mrec)*80,resname(mres)*3,resn*4,atmname*4,
     $           chn_seq(mseq)*1
       character fname*35,aname(mrec)*2,cct*2, zname*8, zchn*1
       double precision prob,xp(mrec),yp(mrec),zp(mrec)
       double precision xct(mseq),yct(mseq),zct(mseq)
       integer j,j1,k,k1,k2,isd

      data resname/'ALA','ARG','ASN','ASP','CYS',
     $             'GLN','GLU','GLY','HIS','ILE',
     $             'LEU','LYS','MET','PHE','PRO',
     $             'SER','THR','TRP','TYR','VAL'/

       zname=fname(1:4)//".pdb"
       open(10,file=zname)

       id = 1
        ires0 = 0
        ires = 0
        nseq = 0
        resnum(1) = 0
        zchn = fname(5:5)
        if (fname(5:5).eq."." .or. fname(5:5).eq." ") zchn=" "
15     continue


      read(10,'(a80)',err=10,end=10) cread(id)
c      read(*,'(a80)',err=10,end=10) cread(id)
      if(cread(id)(1:4) .ne. 'ATOM') goto 15
      if(cread(id)(14:14) .eq. 'H') goto 15
      if(cread(id)(13:13) .eq. 'H') goto 15

      if (zchn.ne." " .and. cread(id)(22:22).ne.zchn ) goto 15

      if(cread(id)(17:17).ne.' ')
     &  READ (cread(id)(57:60),'(f4.2)') prob

      if(cread(id)(17:17).ne.' ' .and. prob.lt.0.5) goto 15

      read(cread(id)(18:21),'(a4)') resn
      READ (cread(id)(23:26),'(i4)') ires1
        if(ires1 .ne. ires0) then
           ires = ires + 1
           ires0 = ires1
          do j1 = 1, 20
           if(resname(j1) .eq. resn(1:3)) then
              irestyp(ires) = j1
           endif
          enddo
        endif

       nseq = ires
       ip_seq(nseq) = ires1
       chn_seq(nseq) = cread(id)(22:22)
       resnum(nseq+1) = id


      read (cread(id)(31:54),'(3f8.3)') xp(id),yp(id),zp(id)
         read(cread(id)(14:17),'(a4)') atmname
c         if(atmname(1:2) .eq. 'OT') atmname = 'O   '
c         if(atmname(1:3) .eq. 'OXT') atmname = 'O   '
         aname(id) = atmname

      id = id + 1
      goto 15

 10   continue
      close(10)


         do k1 = 1, nseq
          j = irestyp(k1)
          isd = 0
          xct(k1) = 0
          yct(k1) = 0
          zct(k1) = 0
          do k2 = resnum(k1)+1, resnum(k1+1)
            cct = aname(k2)(1:2)
            if(j.eq.8 .and. cct.eq.'CA') then   
             xct(k1) = xp(k2)
             yct(k1) = yp(k2)
             zct(k1) = zp(k2)
             isd = 1
            elseif(cct.ne.'CA' .and. cct.ne.'N ' .and.
     &   cct.ne.'C ' .and. cct.ne.'O ') then

             xct(k1) = xct(k1) + xp(k2)
             yct(k1) = yct(k1) + yp(k2)
             zct(k1) = zct(k1) + zp(k2)
             isd = isd + 1
            endif
          enddo
          xct(k1) = xct(k1)/isd
          yct(k1) = yct(k1)/isd
          zct(k1) = zct(k1)/isd

         enddo

      end
